function [qMatcell pMat] = q(data)
im = sqrt(-1);
basisSize = size(data.basis,1);
numexcit = max(max((data.basis)))+1;
%qMat = sparse(zeros([basisSize basisSize]));
numOsc = size(data.basis,2);
usebasis = fliplr(data.basis);

%for mat = size(dataIn.basis,2)

for i=1:numOsc
    thisvec = squeeze(usebasis(:,i))./sqrt(squeeze(usebasis(:,i)));
    thisvec = fixnan(thisvec);
    %thisvec = ones([length(thisvec) 1]);
    st = 1+numexcit.^(i-1);
    qMatcell{i} = spdiags(thisvec(st:end),-(numexcit.^(i-1)),basisSize,basisSize);
end

pMat = qMatcell;

for i=1:numOsc
    pMat{i} = -im*pMat{i} + im*qMatcell{i}';
    qMatcell{i} = qMatcell{i} + qMatcell{i}'; 
    
    qMatcell{i} = qMatcell{i}/sqrt(2);
    pMat{i} = pMat{i}/sqrt(2);
end